;; tos/theme.jl

;; Copyright (C) 2000 Tomas Berndtsson <tomas@nocrew.org>

;; TOS theme is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; TOS theme is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(let*
    ;; 23x23
    ((close (list (make-image "close_normal.ppm") 
		  (make-image "close_active.ppm")
		  nil 
		  (make-image "close_clicked.ppm")))

     (full (list (make-image "full_normal.ppm") 
		 (make-image "full_active.ppm")
		 nil 
		 (make-image "full_clicked.ppm")))

     (iconify (list (make-image "iconify_normal.ppm") 
		 (make-image "iconify_active.ppm")
		 nil 
		 (make-image "iconify_clicked.ppm")))

     (text-colour (lambda (w)
                     (list (or (window-get w 'frame-inactive-color)
                               "white")
                           (or (window-get w 'frame-active-color)
                               "black"))))

     
     (frame `(((background . "#7f7f7f")
	       (left-edge . -1)
	       (right-edge . -1)
	       (top-edge . -23)
	       (height . 23))
	       
	      ((background . "#bfbfbf")
	       (foreground . ,text-colour)
	       (text . ,window-name)
	       (font . "atari8x16")
	       (x-justify . center)
	       (y-justify . center)
	       (left-edge . 23)
	       (right-edge . 45)
	       (top-edge . -21)
	       (height . 19)
	       (class . title))
	       	       	       
	      ((background . "white")
	       (left-edge . 22)
	       (right-edge . 45)
	       (top-edge . -22)
	       (height . 1))

	      ((background . "white")
	       (left-edge . 22)
	       (top-edge . -22)
	       (width . 1)
	       (height . 20))

	      ((background . "#bfbfbf")
	       (left-edge . 22)
	       (top-edge . -2)
	       (width . 1)
	       (height . 1))

	      ((background . "#bfbfbf")
	       (right-edge . 44)
	       (top-edge . -22)
	       (width . 1)
	       (height . 1))

	      ((background . "black")
	       (left-edge . -1)
	       (top-edge . 0)
	       (bottom-edge . -1)
	       (width . 1))

	      ((background . "black")
	       (right-edge . -2)
	       (top-edge . -22)
	       (bottom-edge . -1)
	       (width . 1))

	      ((background . "black")
	       (right-edge . -1)
	       (top-edge . 0)
	       (bottom-edge . -1)
	       (width . 1))

	      ((background . "black")
	       (left-edge . 0)
	       (right-edge . -2)
	       (bottom-edge . -2)
	       (height . 2))

	      ((background . ,iconify)
	       (right-edge . 21)
	       (top-edge . -23)
	       (width . 23)
	       (height . 23)
	       (class . iconify-button)
	       (removable . t))

	      ((background . ,full)
	       (right-edge . -1)
	       (top-edge . -23)
	       (width . 23)
	       (height . 23)
	       (class . maximize-button)
	       (removable . t))

	      ((background . ,close)
	       (left-edge . -1)
	       (top-edge . -23)
	       (width . 23)
	       (height . 23)
	       (class . close-button)
	       (removable . t))))

     (title-frame `(((background . "#7f7f7f")
	       (left-edge . -1)
	       (right-edge . -1)
	       (top-edge . -23)
	       (height . 23))
	       
	      ((background . "#bfbfbf")
	       (foreground . ,text-colour)
	       (text . ,window-name)
	       (font . "atari8x16")
	       (x-justify . center)
	       (y-justify . center)
	       (left-edge . 23)
	       (right-edge . 1)
	       (top-edge . -21)
	       (height . 19)
	       (class . title))
	       	       	       
	      ((background . "white")
	       (left-edge . 22)
	       (right-edge . 1)
	       (top-edge . -22)
	       (height . 1))

	      ((background . "white")
	       (left-edge . 22)
	       (top-edge . -22)
	       (width . 1)
	       (height . 20))

	      ((background . "#bfbfbf")
	       (left-edge . 22)
	       (top-edge . -2)
	       (width . 1)
	       (height . 1))

	      ((background . "#bfbfbf")
	       (right-edge . 0)
	       (top-edge . -22)
	       (width . 1)
	       (height . 1))

	      ((background . "black")
	       (left-edge . -1)
	       (top-edge . 0)
	       (bottom-edge . -1)
	       (width . 1))

	      ((background . "black")
	       (right-edge . -2)
	       (top-edge . -22)
	       (bottom-edge . -1)
	       (width . 1))

	      ((background . "black")
	       (right-edge . -1)
	       (top-edge . 0)
	       (bottom-edge . -1)
	       (width . 1))

	      ((background . "black")
	       (left-edge . 0)
	       (right-edge . -2)
	       (bottom-edge . -2)
	       (height . 2))

	      ((background . ,close)
	       (left-edge . -1)
	       (top-edge . -23)
	       (width . 23)
	       (height . 23)
	       (class . close-button)
	       (removable . t))))

     (border-frame `(((background . "#bfbfbf")
	       (left-edge . -4)
	       (right-edge . -4)
	       (top-edge . -4)
	       (height . 1))
	       	       	       	       
	      ((background . "#bfbfbf")
	       (left-edge . -4)
	       (top-edge . -4)
	       (bottom-edge . -4)
	       (width . 1))

	      ((background . "white")
	       (left-edge . -3)
	       (right-edge . -3)
	       (top-edge . -3)
	       (height . 1))

	      ((background . "white")
	       (left-edge . -3)
	       (top-edge . -3)
	       (bottom-edge . -3)
	       (width . 1))

	      ((background . "white")
	       (left-edge . -2)
	       (right-edge . -2)
	       (top-edge . -2)
	       (height . 1))

	      ((background . "white")
	       (left-edge . -2)
	       (top-edge . -2)
	       (bottom-edge . -2)
	       (width . 1))

	      ((background . "black")
	       (left-edge . -1)
	       (right-edge . -1)
	       (top-edge . -1)
	       (height . 1))

	      ((background . "black")
	       (left-edge . -1)
	       (top-edge . -1)
	       (bottom-edge . -1)
	       (width . 1))


	      ((background . "black")
	       (left-edge . -1)
	       (right-edge . -1)
	       (bottom-edge . -1)
	       (height . 1))

	      ((background . "black")
	       (right-edge . -1)
	       (top-edge . -1)
	       (bottom-edge . -1)
	       (width . 1))

	      ((background . "#7f7f7f")
	       (left-edge . -1)
	       (right-edge . -2)
	       (bottom-edge . -2)
	       (height . 1))

	      ((background . "#7f7f7f")
	       (right-edge . -2)
	       (top-edge . -1)
	       (bottom-edge . -2)
	       (width . 1))

	      ((background . "#7f7f7f")
	       (left-edge . -2)
	       (right-edge . -3)
	       (bottom-edge . -3)
	       (height . 1))

	      ((background . "#7f7f7f")
	       (right-edge . -3)
	       (top-edge . -2)
	       (bottom-edge . -3)
	       (width . 1))

	      ((background . "#7f7f7f")
	       (left-edge . -3)
	       (right-edge . -4)
	       (bottom-edge . -4)
	       (height . 1))

	      ((background . "#7f7f7f")
	       (right-edge . -4)
	       (top-edge . -3)
	       (bottom-edge . -4)
	       (width . 1))))

     (only-title-frame `(((background . "#7f7f7f")
	       (left-edge . -1)
	       (right-edge . -1)
	       (top-edge . -23)
	       (height . 23))
	       
	      ((background . "#bfbfbf")
	       (foreground . ,text-colour)
	       (text . ,window-name)
	       (font . "atari8x16")
	       (x-justify . center)
	       (y-justify . center)
	       (left-edge . 23)
	       (right-edge . 1)
	       (top-edge . -21)
	       (height . 19)
	       (class . title))
	       	       	       
	      ((background . "white")
	       (left-edge . 22)
	       (right-edge . 1)
	       (top-edge . -22)
	       (height . 1))

	      ((background . "white")
	       (left-edge . 22)
	       (top-edge . -22)
	       (width . 1)
	       (height . 20))

	      ((background . "#bfbfbf")
	       (left-edge . 22)
	       (top-edge . -2)
	       (width . 1)
	       (height . 1))

	      ((background . "#bfbfbf")
	       (right-edge . 0)
	       (top-edge . -22)
	       (width . 1)
	       (height . 1))

	      ((background . ,close)
	       (left-edge . -1)
	       (top-edge . -23)
	       (width . 23)
	       (height . 23)
	       (class . close-button)
	       (removable . t)))))

  
  (add-frame-style 'tos
		   (lambda (w type)
		     (cond ((eq type 'shaped)
			    only-title-frame)
			   ((eq type 'transient)
			    border-frame)
			   ((eq type 'shaped-transient)
			    title-frame)
			   ((eq type 'unframed)
			    nil-frame)
			   (t
			    frame)))))

